%define cvsdate 20020524
%undefine cvsdate
%def_with capabilities

%define jackit_tmpdir /var/lib/jack/tmp
%define jackit_tmpdir_type ramfs
%define jackit_group audio

Name: jackit
Version: 0.90.1
%define release alt1

%ifdef cvsdate
Release: %{release}cvs%cvsdate
%else
Release: %release
%endif

%define _name jack
%define package_name jack-audio-connection-kit

Summary: JACK audio connection kit
Summary(ru_RU.KOI8-R):    JACK
Group: Sound
License: GPL/LGPL
Url: http://%name.sourceforge.net
Packager: Yuri N. Sedunov <aris@altlinux.ru>

%ifndef cvsdate
Source: http://prdownloads.sourceforge.net/%name/%package_name-%version.tar.gz
%else
Source: %_name-%cvsdate.tar.bz2
%endif

%if_with capabilities
BuildPreReq: libcap-devel
%endif

# Automatically added by buildreq on Thu Aug 21 2003
#BuildRequires: doxygen gcc-c++ glibc-devel-static libalsa-devel libcap-devel libncurses-devel libreadline-devel libsndfile-devel pkgconfig
BuildRequires: doxygen gcc-c++ glibc-devel-static libalsa-devel libncurses-devel
BuildRequires: libreadline-devel libsndfile-devel pkgconfig

%description
JACK is a low-latency audio server, written primarily for the Linux
operating system. It can connect a number of different applications to
an audio device, as well as allowing them to share audio between
themselves. Its clients can run in their own processes (ie. as a normal
application), or can they can run within a JACK server (ie. as a
"plugin").

JACK is different from other audio server efforts in that it has been
designed from the ground up to be suitable for professional audio work.
This means that it focuses on two key areas: synchronous execution of
all clients, and low latency operation.

Jack is a sound server aimed at satisfying the needs of music
profesionals.

%description -l ru_RU.KOI8-R
JACK --    ,    
  GNU/Linux.      
JACK-        .  
    ,   
 .  JACK    , 
  ""  jackd,   
.

 JACK       ,     
      .   
   JACK      
   .

%package -n jackd
Summary: JACK server
Summary(ru_RU.KOI8-R): jackd --   JACK
Group: System/Servers
Requires: lib%_name = %version-%release

%description -n jackd
JACK is a low-latency audio server, written primarily for the Linux
operating system. It can connect a number of different applications to
an audio device, as well as allowing them to share audio between
themselves. Its clients can run in their own processes (ie. as a normal
application), or can they can run within a JACK server (ie. as a
"plugin").

JACK is different from other audio server efforts in that it has been
designed from the ground up to be suitable for professional audio work.
This means that it focuses on two key areas: synchronous execution of
all clients, and low latency operation.

This package contains jackd - JACK server

%description -l ru_RU.KOI8-R -n jackd
JACK --    ,     
  GNU/Linux.     
JACK-        . 
    ,  
 .  JACK    ,
  ""  jackd,        
.
 
 JACK       ,    
      .  
   JACK     
   .

    jackd --  JACK-

%package -n lib%_name
Summary: Shared libraries to run JACK
Summary(ru_RU.KOI8-R):    JACK
Group: System/Libraries

%description -n lib%_name
This package contains the shared libraries required for jackd.

%description -l ru_RU.KOI8-R -n lib%_name
        
jackd.

%package devel
Summary: Development files for JACK
Summary(ru_RU.KOI8-R):    JACK
Group: Development/C
Requires: lib%_name = %version-%release

%description devel
This package includes the development libraries, header files and
documentation necessary for developing programs which will use JACK.

%description -l ru_RU.KOI8-R devel
   ,    , 
 JACK.

%package -n lib%_name-devel-static
Summary: Static libraries for developing apps using JACK
Summary(ru_RU.KOI8-R):       JACK
Group: Development/C
Requires: %name-devel = %version-%release

%description -n lib%_name-devel-static
This package contains the static libraries you can use to develop
statically linked applications using JACK.

%description -l ru_RU.KOI8-R -n lib%_name-devel-static
   ,    
    lib%_name

%package utils
Summary: Utilities for JACK
Summary(ru_RU.KOI8-R):   JACK 
Group: Sound
Requires: jackd = %version-%release

%description utils
Utilities that control and interact with the JACK server-jackd.

%description -l ru_RU.KOI8-R utils
    ,     JACK 
   .

%prep
%ifndef cvsdate
%setup -q -n %package_name-%version
%else
%setup -q -n %_name
%endif

%build
%ifdef cvsdate
./autogen.sh
%endif

%configure --enable-static \
    --with-default-tmpdir=%jackit_tmpdir \
%if_with capabilities
    --enable-capabilities \
    --enable-stripped-jackd \
%endif
    %{subst_enable resize}

%make_build

%install
%make_install DESTDIR=%buildroot install
%__mkdir_p %buildroot%jackit_tmpdir

# remove non-packaged files
%__rm -rf %buildroot%_datadir/%package_name
%__rm -f %buildroot%_libdir/*.la

%__cat << __INIT__ >rc.%_name
#!/bin/sh
# 
# $Id: %_name,v 1.0 2003/07/18 21:35:24 aris Exp $
#
# This script sets ownership and permissions for mounted jack temporary directory

WITHOUT_RC_COMPAT=1

# Source function library.
. /etc/init.d/functions

if [ -d %jackit_tmpdir ]; then
    echo -ne "Set ownerships for jack temporary directory...\t"
    %__chown root:%jackit_group %jackit_tmpdir && \\
    echo "done" || \\
    { echo "failed to change ownership for jack temporary directory"; exit 0; }
    echo -ne "Set permissions for jack temporary directory...\t"
    %__chmod 1770 %jackit_tmpdir && \\
    echo "done" || \\
    { echo "failed to change permissions for jack temporary directory"; exit 0; }
fi
__INIT__

%__install -pD rc.%_name %buildroot%_initdir/%_name

for n in 2 3 4 5; do
%__mkdir_p %buildroot%_sysconfdir/rc.d/rc"$n".d
%__ln_s ../init.d/%_name %buildroot%_sysconfdir/rc.d/rc"$n".d/S99%_name
done

%post -n jackd
dir="%jackit_tmpdir"
fstype=%jackit_tmpdir_type
fstab=/etc/fstab
mtab=/etc/mtab
fstab_entry="jacktmp	"$dir"	"$fstype"	defaults	0 0"

mount_jackit_tmpdir()
{
echo -ne "Mounting jack temporary directory...\t"
mount $dir && \
echo "done" || \
{ echo "failed to mount jack temporary directory"; exit 0; }
    if [ -f %_initdir/%_name ]; then
	/bin/sh %_initdir/%_name
    fi    
}

if [ -f $fstab ]; then
echo -ne "Finding jack temporary directory mount point in $fstab...\t"
    if grep -qs "jack" $fstab; then
	if ! grep -qs "$dir" $fstab; then
	    echo "found" 
	    echo "but this entry does not match the one needed by jack"
	    echo "Please add the following line to $fstab manually"
	    echo "$fstab_entry"
	else
	    echo "found"
	    if ! grep -qs "$dir" $mtab; then
	    	mount_jackit_tmpdir
	    fi
	fi
    else
	echo "not found"
	echo -ne "Adding jack temporary directory mount point entry to $fstab...\t"
	echo "$fstab_entry" >> $fstab && \
	echo "done" || \
	{ echo "failed"; exit 0; }
	mount_jackit_tmpdir
    fi
fi

%post -n lib%_name -p %post_ldconfig
%postun -n lib%_name -p %postun_ldconfig

%files -n jackd
%if_with capabilities
%attr(4710,root,%jackit_group) %_bindir/jackstart
%endif
%_bindir/jackd
%_man1dir/*
%config %_initdir/jack
%_sysconfdir/rc.d/rc*.d/S99jack
%attr(1770,root,%jackit_group) %jackit_tmpdir
%doc AUTHORS TODO COPYING README

%files -n lib%_name
%_libdir/*.so.*
%dir %_libdir/%_name
%_libdir/%_name/*.so

%files devel
%_includedir/*
%_libdir/*.so
%_libdir/pkgconfig/*
%doc doc/reference/html

%files -n lib%_name-devel-static
%_libdir/*.a
%_libdir/%_name/*.a

%files utils
%_bindir/%{_name}_*
%_bindir/%{_name}rec

%changelog
* Wed Nov 26 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.90.1-alt1
- 0.90.1
- don't package .la files.

* Sun Nov 16 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.90.0-alt1
- 0.90.0

* Fri Aug 29 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.80.0-alt1
- 0.80.0

* Thu Aug 21 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.75.0-alt1
- 0.75.0

* Fri Jul 18 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.74.0-alt1
- 0.74.0
- fixed silly bug with chown running from %%_sysconfdir/profile.d/jack.{sh,csh}
- summary, descriptions by avp.

* Mon Jul 14 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.72.4-alt3
- only users from group audio can run jackstart.
- change %%jackit_tmpdir to /var/lib/jack/tmp.
- mount, set ownership and permissions for %%jackit_tmpdir in %%post.
- adjust ownership and permissions for mounted %%jackit_tmpdir on boot.
- summary, descriptions by avp.

* Fri Jul 04 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.72.4-alt2
- jack_time_t defined as a type, patch from cvs.

* Tue Jun 17 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.72.4-alt1
- 0.72.4

* Sat May 10 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.71.1-alt1
- 0.71.1
- compiled --with-default-tmpdir=/mnt/ramfs. (see /usr/share/doc/jackd-0.71.1/README)

* Tue May 06 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.70.4-alt1
- 0.70.4

* Fri Mar 07 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.61.0-alt1
- New version.
- Capabilities enabled (wait for special multimedia kernel).

* Wed Feb 12 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.50.0-alt1
- new version.

* Sun Nov 10 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.34.0-alt0.8
- Built with new libsndfile-1.0.1, libfltk-1.1.0rc7
- Capabilities disabled (unusual for our kernels).

* Tue Aug 13 2002 Grigory Milev <week@altlinux.ru> 0.34.0-alt0.7
- recompile with libfltk-1.1.0rc5

* Fri Aug 09 2002 Stanislav Ievlev <inger@altlinux.ru> 0.34.0-alt0.6
- fixed suid/sgid file permissions

* Wed Jun 05 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.34.0-alt0.5
- 0.34.0
- fixed requires for devel-static package.

* Thu May 23 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.4.7-alt0.5cvs20020523
- built current cvs snapshot.

* Mon Feb 25 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.4.7-alt0.5
- first build for Sisyphus.

